<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Classes/MeleeTargeting.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.19.155390</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d6/d36/_melee_targeting_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">MeleeTargeting.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d6/d36/_melee_targeting_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno"><a class="line" href="../../d8/d52/class_melee_target_data.html">    1</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span>{   </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno"><a class="line" href="../../d8/d52/class_melee_target_data.html#abff57f73e043bd0cb8d801bc83ee9cfa">    3</a></span>    <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#abff57f73e043bd0cb8d801bc83ee9cfa">Obj</a>;</div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno"><a class="line" href="../../d8/d52/class_melee_target_data.html#a0eb9a6b8ca37fd3d1403884557fa27af">    4</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#a0eb9a6b8ca37fd3d1403884557fa27af">HitPos</a>;</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno"><a class="line" href="../../d8/d52/class_melee_target_data.html#a8a95f9d1cde3f7c4c7ebb4d4b683cddd">    5</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#a8a95f9d1cde3f7c4c7ebb4d4b683cddd">HitComponent</a>;</div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>    </div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno"><a class="line" href="../../d8/d52/class_melee_target_data.html#a8b6adaaa45ac0448b13e0c00abbccaba">    7</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d8/d52/class_melee_target_data.html#a8b6adaaa45ac0448b13e0c00abbccaba">MeleeTargetData</a>(<a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> o, <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> p, <span class="keywordtype">int</span> c)</div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>    {</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>        <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#abff57f73e043bd0cb8d801bc83ee9cfa">Obj</a> = o;</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>        <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#a0eb9a6b8ca37fd3d1403884557fa27af">HitPos</a> = p;</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>        <a class="code hl_variable" href="../../d8/d52/class_melee_target_data.html#a8a95f9d1cde3f7c4c7ebb4d4b683cddd">HitComponent</a> = c;</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>    }</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>}</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span> </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="keyword">class </span><a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>{</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#abbc37d781289db9c7e3e136ba74f181c">   17</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#abbc37d781289db9c7e3e136ba74f181c">ConeOrigin</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a38272d87055f23cc1eeefd46d3432a49">   18</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a38272d87055f23cc1eeefd46d3432a49">ConeLength</a>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#ac05cbefecbadd6e2fe61527d0e812fd4">   19</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ac05cbefecbadd6e2fe61527d0e812fd4">ConeHalfAngle</a>;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a00137dd71d8e1deec6d035482ff158f5">   20</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a00137dd71d8e1deec6d035482ff158f5">ConeHalfAngleRad</a>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a349dad056bd29f0b6a142407772002f1">   21</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a349dad056bd29f0b6a142407772002f1">ConeMinHeight</a>;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a9de57d406c8e03911bb43c28a1d9b78c">   22</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a9de57d406c8e03911bb43c28a1d9b78c">ConeMaxHeight</a>;</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>    </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a08b3ad31e649490d186cc4aa186dca18">   24</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a08b3ad31e649490d186cc4aa186dca18">ConeLeftPoint</a>;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a3a8b9b8be80f4c0870a02ed82ad63b7d">   25</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a3a8b9b8be80f4c0870a02ed82ad63b7d">ConeRightPoint</a>;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#acd828993da09318d43417cb2b979c9b2">   27</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#acd828993da09318d43417cb2b979c9b2">RayStart</a>;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#aeecfd35041492b39af2cfcd8731769d8">   28</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#aeecfd35041492b39af2cfcd8731769d8">RayEnd</a>;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#ab5186b23cc595fd58ab0e9b80362287c">   29</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ab5186b23cc595fd58ab0e9b80362287c">Dir</a>;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">   30</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>;</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a85e5d87bda6d1598d1de512ee5a880d9">   31</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a85e5d87bda6d1598d1de512ee5a880d9">MaxDist</a>;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a8aa57ad149afa728ed043745d1818a16">   33</a></span>    <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a8aa57ad149afa728ed043745d1818a16">Attacker</a>;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    ref <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;typename&gt;</a> TargetableObjects</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">   36</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a>(<a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> coneOrigin, <span class="keywordtype">float</span> coneLength, <span class="keywordtype">float</span> coneHalfAngle, <span class="keywordtype">float</span> coneMinHeight, <span class="keywordtype">float</span> coneMaxHeight, <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> rayStart, <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> dir, <span class="keywordtype">float</span> maxDist, <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> pToIgnore, <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;typename&gt;</a> targetableObjects)</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#abbc37d781289db9c7e3e136ba74f181c">ConeOrigin</a>          = coneOrigin;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a38272d87055f23cc1eeefd46d3432a49">ConeLength</a>          = coneLength;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ac05cbefecbadd6e2fe61527d0e812fd4">ConeHalfAngle</a>       = coneHalfAngle;</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a00137dd71d8e1deec6d035482ff158f5">ConeHalfAngleRad</a>    = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_variable" href="../../d5/d98/group___math.html#gadf6cda0885b5257cc109a3420ea11cd6">DEG2RAD</a> * coneHalfAngle;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a349dad056bd29f0b6a142407772002f1">ConeMinHeight</a>       = coneMinHeight;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a9de57d406c8e03911bb43c28a1d9b78c">ConeMaxHeight</a>       = coneMaxHeight;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#acd828993da09318d43417cb2b979c9b2">RayStart</a>            = rayStart;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#aeecfd35041492b39af2cfcd8731769d8">RayEnd</a>              = rayStart + <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga1ea52907ba49a5706b41108910975de7">SqrFloat</a>(coneLength) * dir;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        </div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ab5186b23cc595fd58ab0e9b80362287c">Dir</a>                 = dir; </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>        </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>               = dir;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>[1]            = 0;</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>.<a class="code hl_function" href="../../d7/dfc/classvector.html#a77831ca9c077a8dbd1b0aae7ba2a5d3d">Normalize</a>();</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        </div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a85e5d87bda6d1598d1de512ee5a880d9">MaxDist</a>             = maxDist;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a8aa57ad149afa728ed043745d1818a16">Attacker</a>            = pToIgnore;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        TargetableObjects   = targetableObjects;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <span class="comment">// Calculate cone points</span></div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>        <a class="code hl_class" href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a>.<a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#gaa5d7b9d9e2c8f7d42e0e63415e512d20">ConePoints</a>(<a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#abbc37d781289db9c7e3e136ba74f181c">ConeOrigin</a>, <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a38272d87055f23cc1eeefd46d3432a49">ConeLength</a>, <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a00137dd71d8e1deec6d035482ff158f5">ConeHalfAngleRad</a>, -<a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga87cce5b3869bb15303abcbe531f50d32">Atan2</a>(<a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>[0], <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a>[2]), <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a08b3ad31e649490d186cc4aa186dca18">ConeLeftPoint</a>, <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#a3a8b9b8be80f4c0870a02ed82ad63b7d">ConeRightPoint</a>);</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>    }</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>}</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span> </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno"><a class="line" href="../../d2/d0e/class_component_result.html">   64</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a></div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>{</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="../../d2/d0e/class_component_result.html#a7d882d244e75a1ca8dd4ba15348de4a1">   66</a></span>    <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> <a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a7d882d244e75a1ca8dd4ba15348de4a1">ComponentPos</a>;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno"><a class="line" href="../../d2/d0e/class_component_result.html#a0c9105d04f100f45351dd9d1efb53272">   67</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a0c9105d04f100f45351dd9d1efb53272">ComponentAngle</a>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">   68</a></span>    <span class="keywordtype">float</span> <a class="code hl_variable" href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">ComponentDistance2</a>;</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="../../d2/d0e/class_component_result.html#af6550203f42ccafe9895b10c48a8b3eb">   69</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../d2/d0e/class_component_result.html#af6550203f42ccafe9895b10c48a8b3eb">ComponentIdx</a>;</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>}</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span><span class="keyword">class </span>MeleeTargeting</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>{</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#ac13b604a9b03e171d1339324d14dede1">   74</a></span>    <span class="keyword">const</span> <span class="keyword">static</span> <a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a> <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ac13b604a9b03e171d1339324d14dede1">MELEE_TARGET_OBSTRUCTION_LAYERS</a> = <a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.BUILDING|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.DOOR|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.VEHICLE|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.ROADWAY|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.TERRAIN|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.ITEM_SMALL|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.ITEM_LARGE|<a class="code hl_enumeration" href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a>.FENCE;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#ac20aab97be05c9477a398c23fbcff3bd">   76</a></span>    <a class="code hl_class" href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ac20aab97be05c9477a398c23fbcff3bd">GetMeleeTargetEx</a>(<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;Object&gt;</a> allTargets = null, <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;string&gt;</a> blacklistedDamageZones = null)</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    {</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        <a class="code hl_class" href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a> ret;</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        <span class="comment">// Easier access to MeleeTargetSettings variables</span></div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a>  coneOrigin                  = settings.ConeOrigin;</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>        <span class="keywordtype">float</span>   coneLength                  = settings.ConeLength;</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>        <span class="keywordtype">float</span>   coneHalfAngle               = settings.ConeHalfAngle;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        <span class="keywordtype">float</span>   radAngle                    = settings.ConeHalfAngleRad;</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        <span class="keywordtype">float</span>   coneMinHeight               = settings.ConeMinHeight;</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        <span class="keywordtype">float</span>   coneMaxHeight               = settings.ConeMaxHeight;</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        </div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> coneLeft                     = settings.ConeLeftPoint;</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> coneRight                    = settings.ConeRightPoint;</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        </div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> rayStart                     = settings.RayStart;</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> rayEnd                       = settings.RayEnd;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> dir                          = settings.Dir;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> xzDir                        = settings.XZDir;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        <span class="keywordtype">float</span> maxDist                       = settings.MaxDist;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> pToIgnore                  = settings.Attacker;</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;typename&gt;</a> targetableObjects   = settings.TargetableObjects;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        </div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>        <span class="comment">// Calculate box size</span></div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        <span class="keywordtype">float</span> boxWidth = <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a>.<a class="code hl_function" href="../../d7/dfc/classvector.html#aad57f4c847a6ad08cf88f390961dd2db">Distance</a>(coneLeft, coneRight);      </div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>        <span class="keywordtype">float</span> boxHeight = coneMaxHeight - coneMinHeight;</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        </div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> boxSize = <a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#ga5bd1deb1c96276d94eeec6fe40955c41">Vector</a>(boxWidth, boxHeight, coneLength);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        <span class="comment">// Calculate box center</span></div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> centerHeight = <a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#ga5bd1deb1c96276d94eeec6fe40955c41">Vector</a>(0, <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga1ac33c7be3c1e52ae6b70fe58c78266c">Lerp</a>(coneMinHeight, coneMaxHeight, 0.5), 0);</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> offset = xzDir * coneLength * 0.5;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> boxCenter = coneOrigin + offset + centerHeight;</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        </div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        <span class="comment">// Gather all targets</span></div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <a class="code hl_class" href="../../da/d47/class_box_colliding_params.html">BoxCollidingParams</a> params = <span class="keyword">new</span> <a class="code hl_class" href="../../da/d47/class_box_colliding_params.html">BoxCollidingParams</a>();</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>        params.<a class="code hl_function" href="../../da/d47/class_box_colliding_params.html#a34d684eab590842b72771c277df26e7d">SetParams</a>(boxCenter, xzDir.<a class="code hl_function" href="../../d7/dfc/classvector.html#aed751dee971a2a172f3052c68f607111">VectorToAngles</a>(), boxSize, ObjIntersect.Fire, ObjIntersect.Fire, <span class="keyword">true</span>);</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>        <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref BoxCollidingResult&gt;</a> results = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;ref BoxCollidingResult&gt;</a>;</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>        <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;Object&gt;</a> toIgnore = { pToIgnore };</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().IsBoxCollidingGeometryProxy(params, toIgnore, results))</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        {</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>            <span class="comment">//</span></div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>            <span class="keywordtype">float</span>   retVal  = <span class="keywordtype">float</span>.MAX;</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>            <span class="keywordtype">float</span>   tgAngle = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga5e7cfa6eb9adaec1bb0ee6314bd32c2c">Tan</a>(radAngle);   </div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        </div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span><span class="preprocessor">            #ifdef DEVELOPER</span></div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>            <span class="keywordflow">if</span> (<a class="code hl_class" href="../../dc/d49/group___diag_menu.html#d2/dd2/class_diag_menu">DiagMenu</a>.<a class="code hl_function" href="../../dc/d49/group___diag_menu.html#ga7393b4dbcb2442ab520c89d54b390fed">GetBool</a>(<a class="code hl_enumeration" href="../../d9/dbc/_e_diag_menu_i_ds_8c.html#a85affb4d5021d4465be4205f8cd4e336">DiagMenuIDs</a>.DM_MELEE_DRAW_RANGE) &amp;&amp; <a class="code hl_class" href="../../dc/d49/group___diag_menu.html#d2/dd2/class_diag_menu">DiagMenu</a>.<a class="code hl_function" href="../../dc/d49/group___diag_menu.html#ga7393b4dbcb2442ab520c89d54b390fed">GetBool</a>(<a class="code hl_enumeration" href="../../d9/dbc/_e_diag_menu_i_ds_8c.html#a85affb4d5021d4465be4205f8cd4e336">DiagMenuIDs</a>.DM_MELEE_DEBUG_ENABLE))</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>                <a class="code hl_class" href="../../da/d7d/class_debug.html">Debug</a>.<a class="code hl_function" href="../../da/d7d/class_debug.html#af7d58ee7a0b3ff54b49a277dbdd09db6">DrawLine</a>(rayStart, rayEnd, <a class="code hl_variable" href="../../dd/d13/group___colors.html#ga99b2555651fb3bdd7bca23e5b6553968">COLOR_GREEN</a>, <a class="code hl_enumeration" href="../../d6/dae/group___debug_shape.html#gae99018d13c3c8a3cc164600046082d04">ShapeFlags</a>.ONCE);</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span><span class="preprocessor">            #endif</span></div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>            </div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>            <span class="comment">// Find the most suitable target</span></div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            <span class="keywordflow">foreach</span> (BoxCollidingResult bResult : results)</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>            {</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>                <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> obj = bResult.obj;</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>                </div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>                <span class="comment">// Check for targetable objects</span></div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>                <span class="keywordflow">if</span> (!obj.IsAnyInherited(targetableObjects) || !obj.IsAlive())</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>                {</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>                }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>                </div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>                <span class="comment">// Ready the defaults for the object</span></div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> targetPos = obj.GetPosition();                           </div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                <span class="keywordtype">float</span> targetAngle = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_variable" href="../../d5/d98/group___math.html#gad73851cb23a468ee6eb705d0ec76e141">RAD2DEG</a> * <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#gadf8820d46eee5033af2e12212c22b16e">AbsFloat</a>(<a class="code hl_class" href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a>.<a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#ga6355d439d382de23a6bde149dce4ce27">AngleFromPosition</a>(coneOrigin, dir, targetPos)); </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>                <span class="keywordtype">float</span> targetDistance2 = <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a>.<a class="code hl_function" href="../../d7/dfc/classvector.html#a21d8662c860e105943718b2da59349e7">DistanceSq</a>(targetPos, <a class="code hl_class" href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a>.<a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#gaa40fb02e82bbd890f161df78fc8cdc55">NearestPoint</a>(rayStart, rayEnd, targetPos)); </div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>                <span class="keywordtype">int</span> hitComponent = -1;</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>                <span class="keywordtype">float</span> csSum = <span class="keywordtype">float</span>.<a class="code hl_variable" href="../../d4/dc3/classfloat.html#a984911aa6072c232bb876de8ed8904af">MAX</a>;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>                </div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>                <span class="comment">// Find the most suitable component</span></div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>                <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> result;</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>                <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">FindMostSuitableComponentEx</a>(obj, bResult, settings, csSum, result, blacklistedDamageZones))</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>                {</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>                    targetPos       = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a7d882d244e75a1ca8dd4ba15348de4a1">ComponentPos</a>;</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>                    targetAngle     = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a0c9105d04f100f45351dd9d1efb53272">ComponentAngle</a>;</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>                    targetDistance2 = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">ComponentDistance2</a>;</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>                    hitComponent    = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#af6550203f42ccafe9895b10c48a8b3eb">ComponentIdx</a>;</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>                }</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span> </div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>                <span class="comment">// ProxyInfo</span></div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>                <span class="keywordflow">if</span> (bResult.proxyInfo)</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>                {</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>                    <span class="keywordflow">foreach</span> (BoxCollidingResult pInfo : bResult.proxyInfo)</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>                    {</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>                        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">FindMostSuitableComponentEx</a>(obj, pInfo, settings, csSum, result, blacklistedDamageZones))</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>                        {</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>                            targetPos       = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a7d882d244e75a1ca8dd4ba15348de4a1">ComponentPos</a>;                          </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>                            targetAngle     = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#a0c9105d04f100f45351dd9d1efb53272">ComponentAngle</a>;    </div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>                            targetDistance2 = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">ComponentDistance2</a>;    </div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>                            hitComponent    = result.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#af6550203f42ccafe9895b10c48a8b3eb">ComponentIdx</a>;</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>                        }</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>                    }</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>                }</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>                </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>                <span class="comment">// No suitable component found</span></div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>                <span class="keywordflow">if</span> (hitComponent == -1 || csSum == <span class="keywordtype">float</span>.<a class="code hl_variable" href="../../d0/d13/_en_convert_8c.html#af7dbda7167e22cb3417c16f78061ad80">MAX</a>)</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>                {</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>                }</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span> </div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>                <span class="comment">// Check if it is a better fit than what has been found previously</span></div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>                <span class="keywordtype">float</span> sum  = targetDistance2;</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>                <span class="keywordflow">if</span> (sum &lt; retVal)</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>                {</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>                    ret     = <span class="keyword">new</span> <a class="code hl_class" href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a>(obj, targetPos, hitComponent);</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>                    retVal  = sum;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>                }</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>    </div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>                allTargets.Insert(obj);</div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>            }</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>        }</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        </div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="keywordflow">return</span> ret;</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>    }</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>    </div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a9abda82bd46a224427372aafdea58bcf">  192</a></span>    <a class="code hl_class" href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a9abda82bd46a224427372aafdea58bcf">GetMeleeTarget</a>(<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;Object&gt;</a> allTargets = null)</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>    {</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ac20aab97be05c9477a398c23fbcff3bd">GetMeleeTargetEx</a>(settings, allTargets);</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    }</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>    </div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">  198</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">FindMostSuitableComponentEx</a>(<a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> obj, BoxCollidingResult bResult, <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out <span class="keywordtype">float</span> sum, out ref <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> result, <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;string&gt;</a> blacklistedDamageZones)</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>    {</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>        <span class="keywordflow">foreach</span> (ComponentInfo cInfo : bResult.componentInfo)</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>        {</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>            <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> cResult = <span class="keyword">new</span> <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a>;</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>            </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>            <span class="keywordflow">if</span> (!<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a88cfc098f3904558278a46bcf442c43f">EvaluateComponentEx</a>(obj, cInfo, settings, cResult, blacklistedDamageZones))</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>            {</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>                <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>            }</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>            </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>            <span class="comment">// Smallest number is a winner</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>            <span class="keywordtype">float</span> cSum = cResult.<a class="code hl_variable" href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">ComponentDistance2</a>;</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            <span class="keywordflow">if</span> (cSum &lt; sum)</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>            {</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>                sum = cSum;             </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>                result = cResult;               </div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>            }</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>        }</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>        </div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>        <span class="keywordflow">return</span> result != null;</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>    }</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span> </div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a6e273265ac4ffdf5084f98823c2942cb">  221</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a6e273265ac4ffdf5084f98823c2942cb">FindMostSuitableComponent</a>(<a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> obj, BoxCollidingResult bResult, <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out <span class="keywordtype">float</span> sum, out ref <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> result)</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>    {</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">FindMostSuitableComponentEx</a>(obj, bResult, settings, sum, result, null);</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>    }</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>    </div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a88cfc098f3904558278a46bcf442c43f">  226</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a88cfc098f3904558278a46bcf442c43f">EvaluateComponentEx</a>(<a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> obj, ComponentInfo cInfo, <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out ref <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> result, <a class="code hl_class" href="../../d2/d41/classarray.html">array&lt;string&gt;</a> blacklistedDamageZones)</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>    {</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> zoneName: blacklistedDamageZones)</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>        {</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>            <span class="keywordflow">if</span> (obj.GetDamageZoneNameByComponentIndex(cInfo.component) == zoneName)</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>            {</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>            }</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>        }</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> componentPos = cInfo.componentCenter;</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        </div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>        <span class="comment">// Too far away! (fast reject)</span></div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>        <span class="keywordtype">float</span> componentMaxDist2 = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga1ea52907ba49a5706b41108910975de7">SqrFloat</a>(settings.MaxDist + cInfo.componentRadius * obj.GetScale());</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> nearestPoint = <a class="code hl_class" href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a>.<a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#gaa40fb02e82bbd890f161df78fc8cdc55">NearestPoint</a>(settings.RayStart, settings.RayEnd, componentPos);</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>        <span class="keywordtype">float</span> componentDistance2 = <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a>.<a class="code hl_function" href="../../d7/dfc/classvector.html#a21d8662c860e105943718b2da59349e7">DistanceSq</a>(componentPos, nearestPoint);</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>        <span class="keywordflow">if</span> (componentDistance2 &gt; componentMaxDist2)</div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>        {</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        }</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>        </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        <span class="comment">// Here some more accurate check could be placed that would adjust the componentPos</span></div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>        </div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        <span class="comment">// Outside of the cone angle!</span></div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        <span class="keywordtype">float</span> componentAngle = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_variable" href="../../d5/d98/group___math.html#gad73851cb23a468ee6eb705d0ec76e141">RAD2DEG</a> * <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#gadf8820d46eee5033af2e12212c22b16e">AbsFloat</a>(<a class="code hl_class" href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a>.<a class="code hl_function" href="../../d5/dc8/group___math3_d_a_p_i.html#ga6355d439d382de23a6bde149dce4ce27">AngleFromPosition</a>(settings.ConeOrigin, settings.XZDir, componentPos));   </div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>        <span class="keywordflow">if</span> (componentAngle &gt; settings.ConeHalfAngle)</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>        {</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>        }</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span>            </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>        <span class="comment">// Obstructed!</span></div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#aa2340358725569e94d8653af6a0bfef5">IsMeleeTargetObstructed</a>(settings.RayStart, componentPos))</div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>        {</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span>        }</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span> </div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>        <span class="comment">// We found something, fill it in!</span></div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>        result.ComponentPos = componentPos;</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        result.ComponentAngle = componentAngle;</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>        result.ComponentDistance2 = componentDistance2;</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>        result.ComponentIdx = cInfo.component;</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>        </div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>    }</div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>    </div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#a75f648ab805d72f264afa22111ff3423">  272</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a75f648ab805d72f264afa22111ff3423">EvaluateComponent</a>(<a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> obj, ComponentInfo cInfo, <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a> settings, out ref <a class="code hl_class" href="../../d2/d0e/class_component_result.html">ComponentResult</a> result)</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>    {</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#a88cfc098f3904558278a46bcf442c43f">EvaluateComponentEx</a>(obj, cInfo, settings, result, {});</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>    }</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span>    </div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno"><a class="line" href="../../d6/d36/_melee_targeting_8c.html#aa2340358725569e94d8653af6a0bfef5">  277</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d6/d36/_melee_targeting_8c.html#aa2340358725569e94d8653af6a0bfef5">IsMeleeTargetObstructed</a>(<a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> rayStart, <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> rayEnd)</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>    {</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span>        <span class="keywordflow">if</span> (rayStart == rayEnd)</div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>        {</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>            <span class="keywordflow">return</span> <span class="keyword">true</span>; <span class="comment">// Not possible to trace when this happens (zero length raycast)</span></div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>        }</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>        </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>        <a class="code hl_class" href="../../d8/d83/class_object.html">Object</a> hitObject;</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>        <a class="code hl_class" href="../../d7/dfc/classvector.html">vector</a> hitPos, hitNormal;</div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>        <span class="keywordtype">float</span> hitFraction;</div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span> </div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>        <span class="keywordflow">return</span> <a class="code hl_class" href="../../d3/d27/class_day_z_physics.html">DayZPhysics</a>.<a class="code hl_function" href="../../d3/d27/class_day_z_physics.html#ac3d59bfe53ca68ae361735a40f548de2">RayCastBullet</a>( rayStart, rayEnd, <a class="code hl_variable" href="../../d6/d36/_melee_targeting_8c.html#ac13b604a9b03e171d1339324d14dede1">MELEE_TARGET_OBSTRUCTION_LAYERS</a>, null, hitObject, hitPos, hitNormal, hitFraction);</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>    }</div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span>}</div>
<div class="ttc" id="a_day_z_physics_8c_html_a726c859fa381777c5894cba896f7db3a"><div class="ttname"><a href="../../d6/de4/_day_z_physics_8c.html#a726c859fa381777c5894cba896f7db3a">PhxInteractionLayers</a></div><div class="ttdeci">PhxInteractionLayers</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/de4/_day_z_physics_8c_source.html#l00001">DayZPhysics.c:2</a></div></div>
<div class="ttc" id="a_e_diag_menu_i_ds_8c_html_a85affb4d5021d4465be4205f8cd4e336"><div class="ttname"><a href="../../d9/dbc/_e_diag_menu_i_ds_8c.html#a85affb4d5021d4465be4205f8cd4e336">DiagMenuIDs</a></div><div class="ttdeci">DiagMenuIDs</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dbc/_e_diag_menu_i_ds_8c_source.html#l00001">EDiagMenuIDs.c:2</a></div></div>
<div class="ttc" id="a_en_convert_8c_html_af7dbda7167e22cb3417c16f78061ad80"><div class="ttname"><a href="../../d0/d13/_en_convert_8c.html#af7dbda7167e22cb3417c16f78061ad80">MAX</a></div><div class="ttdeci">const int MAX</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d13/_en_convert_8c_source.html#l00021">EnConvert.c:21</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a00137dd71d8e1deec6d035482ff158f5"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a00137dd71d8e1deec6d035482ff158f5">ConeHalfAngleRad</a></div><div class="ttdeci">float ConeHalfAngleRad</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00020">MeleeTargeting.c:20</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a08b3ad31e649490d186cc4aa186dca18"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a08b3ad31e649490d186cc4aa186dca18">ConeLeftPoint</a></div><div class="ttdeci">vector ConeLeftPoint</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00024">MeleeTargeting.c:24</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a2e37c0bc6a0567031970d80e98102781"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a2e37c0bc6a0567031970d80e98102781">MeleeTargetSettings</a></div><div class="ttdeci">ref array&lt; typename &gt; TargetableObjects void MeleeTargetSettings(vector coneOrigin, float coneLength, float coneHalfAngle, float coneMinHeight, float coneMaxHeight, vector rayStart, vector dir, float maxDist, EntityAI pToIgnore, array&lt; typename &gt; targetableObjects)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00036">MeleeTargeting.c:36</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a349dad056bd29f0b6a142407772002f1"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a349dad056bd29f0b6a142407772002f1">ConeMinHeight</a></div><div class="ttdeci">float ConeMinHeight</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00021">MeleeTargeting.c:21</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a38272d87055f23cc1eeefd46d3432a49"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a38272d87055f23cc1eeefd46d3432a49">ConeLength</a></div><div class="ttdeci">float ConeLength</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00018">MeleeTargeting.c:18</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a3a8b9b8be80f4c0870a02ed82ad63b7d"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a3a8b9b8be80f4c0870a02ed82ad63b7d">ConeRightPoint</a></div><div class="ttdeci">vector ConeRightPoint</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00025">MeleeTargeting.c:25</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a6a0679651c3333c5df568b189157fee6"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a6a0679651c3333c5df568b189157fee6">XZDir</a></div><div class="ttdeci">vector XZDir</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00030">MeleeTargeting.c:30</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a6e273265ac4ffdf5084f98823c2942cb"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a6e273265ac4ffdf5084f98823c2942cb">FindMostSuitableComponent</a></div><div class="ttdeci">bool FindMostSuitableComponent(Object obj, BoxCollidingResult bResult, MeleeTargetSettings settings, out float sum, out ref ComponentResult result)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00221">MeleeTargeting.c:221</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a75f648ab805d72f264afa22111ff3423"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a75f648ab805d72f264afa22111ff3423">EvaluateComponent</a></div><div class="ttdeci">bool EvaluateComponent(Object obj, ComponentInfo cInfo, MeleeTargetSettings settings, out ref ComponentResult result)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00272">MeleeTargeting.c:272</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a85e5d87bda6d1598d1de512ee5a880d9"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a85e5d87bda6d1598d1de512ee5a880d9">MaxDist</a></div><div class="ttdeci">float MaxDist</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00031">MeleeTargeting.c:31</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a88cfc098f3904558278a46bcf442c43f"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a88cfc098f3904558278a46bcf442c43f">EvaluateComponentEx</a></div><div class="ttdeci">bool EvaluateComponentEx(Object obj, ComponentInfo cInfo, MeleeTargetSettings settings, out ref ComponentResult result, array&lt; string &gt; blacklistedDamageZones)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00226">MeleeTargeting.c:226</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a8aa57ad149afa728ed043745d1818a16"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a8aa57ad149afa728ed043745d1818a16">Attacker</a></div><div class="ttdeci">EntityAI Attacker</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00033">MeleeTargeting.c:33</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a9abda82bd46a224427372aafdea58bcf"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a9abda82bd46a224427372aafdea58bcf">GetMeleeTarget</a></div><div class="ttdeci">MeleeTargetData GetMeleeTarget(MeleeTargetSettings settings, out array&lt; Object &gt; allTargets=null)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00192">MeleeTargeting.c:192</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_a9de57d406c8e03911bb43c28a1d9b78c"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#a9de57d406c8e03911bb43c28a1d9b78c">ConeMaxHeight</a></div><div class="ttdeci">float ConeMaxHeight</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00022">MeleeTargeting.c:22</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_aa2340358725569e94d8653af6a0bfef5"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#aa2340358725569e94d8653af6a0bfef5">IsMeleeTargetObstructed</a></div><div class="ttdeci">bool IsMeleeTargetObstructed(vector rayStart, vector rayEnd)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00277">MeleeTargeting.c:277</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_ab5186b23cc595fd58ab0e9b80362287c"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#ab5186b23cc595fd58ab0e9b80362287c">Dir</a></div><div class="ttdeci">vector Dir</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00029">MeleeTargeting.c:29</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_ab5e4535f165fd45969956c3f4b3e5c9e"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#ab5e4535f165fd45969956c3f4b3e5c9e">FindMostSuitableComponentEx</a></div><div class="ttdeci">bool FindMostSuitableComponentEx(Object obj, BoxCollidingResult bResult, MeleeTargetSettings settings, out float sum, out ref ComponentResult result, array&lt; string &gt; blacklistedDamageZones)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00198">MeleeTargeting.c:198</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_abbc37d781289db9c7e3e136ba74f181c"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#abbc37d781289db9c7e3e136ba74f181c">ConeOrigin</a></div><div class="ttdeci">class MeleeTargetData ConeOrigin</div></div>
<div class="ttc" id="a_melee_targeting_8c_html_ac05cbefecbadd6e2fe61527d0e812fd4"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#ac05cbefecbadd6e2fe61527d0e812fd4">ConeHalfAngle</a></div><div class="ttdeci">float ConeHalfAngle</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00019">MeleeTargeting.c:19</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_ac13b604a9b03e171d1339324d14dede1"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#ac13b604a9b03e171d1339324d14dede1">MELEE_TARGET_OBSTRUCTION_LAYERS</a></div><div class="ttdeci">class ComponentResult MELEE_TARGET_OBSTRUCTION_LAYERS</div></div>
<div class="ttc" id="a_melee_targeting_8c_html_ac20aab97be05c9477a398c23fbcff3bd"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#ac20aab97be05c9477a398c23fbcff3bd">GetMeleeTargetEx</a></div><div class="ttdeci">MeleeTargetData GetMeleeTargetEx(MeleeTargetSettings settings, out array&lt; Object &gt; allTargets=null, array&lt; string &gt; blacklistedDamageZones=null)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00076">MeleeTargeting.c:76</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_acd828993da09318d43417cb2b979c9b2"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#acd828993da09318d43417cb2b979c9b2">RayStart</a></div><div class="ttdeci">vector RayStart</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00027">MeleeTargeting.c:27</a></div></div>
<div class="ttc" id="a_melee_targeting_8c_html_aeecfd35041492b39af2cfcd8731769d8"><div class="ttname"><a href="../../d6/d36/_melee_targeting_8c.html#aeecfd35041492b39af2cfcd8731769d8">RayEnd</a></div><div class="ttdeci">vector RayEnd</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00028">MeleeTargeting.c:28</a></div></div>
<div class="ttc" id="aclass_box_colliding_params_html"><div class="ttname"><a href="../../da/d47/class_box_colliding_params.html">BoxCollidingParams</a></div><div class="ttdoc">Class that holds parameters to feed into CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00002">IsBoxCollidingGeometryProxyClasses.c:3</a></div></div>
<div class="ttc" id="aclass_box_colliding_params_html_a34d684eab590842b72771c277df26e7d"><div class="ttname"><a href="../../da/d47/class_box_colliding_params.html#a34d684eab590842b72771c277df26e7d">BoxCollidingParams::SetParams</a></div><div class="ttdeci">proto native void SetParams(vector center, vector orientation, vector edgeLength, ObjIntersect primaryType, ObjIntersect secondaryType, bool fullComponentInfo)</div><div class="ttdoc">Set the parameters.</div></div>
<div class="ttc" id="aclass_component_result_html"><div class="ttname"><a href="../../d2/d0e/class_component_result.html">ComponentResult</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00064">MeleeTargeting.c:65</a></div></div>
<div class="ttc" id="aclass_component_result_html_a0c9105d04f100f45351dd9d1efb53272"><div class="ttname"><a href="../../d2/d0e/class_component_result.html#a0c9105d04f100f45351dd9d1efb53272">ComponentResult::ComponentAngle</a></div><div class="ttdeci">float ComponentAngle</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00067">MeleeTargeting.c:67</a></div></div>
<div class="ttc" id="aclass_component_result_html_a7d882d244e75a1ca8dd4ba15348de4a1"><div class="ttname"><a href="../../d2/d0e/class_component_result.html#a7d882d244e75a1ca8dd4ba15348de4a1">ComponentResult::ComponentPos</a></div><div class="ttdeci">vector ComponentPos</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00066">MeleeTargeting.c:66</a></div></div>
<div class="ttc" id="aclass_component_result_html_adccdd887b68b5f059201d12436c880e6"><div class="ttname"><a href="../../d2/d0e/class_component_result.html#adccdd887b68b5f059201d12436c880e6">ComponentResult::ComponentDistance2</a></div><div class="ttdeci">float ComponentDistance2</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00068">MeleeTargeting.c:68</a></div></div>
<div class="ttc" id="aclass_component_result_html_af6550203f42ccafe9895b10c48a8b3eb"><div class="ttname"><a href="../../d2/d0e/class_component_result.html#af6550203f42ccafe9895b10c48a8b3eb">ComponentResult::ComponentIdx</a></div><div class="ttdeci">int ComponentIdx</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00069">MeleeTargeting.c:69</a></div></div>
<div class="ttc" id="aclass_day_z_physics_html"><div class="ttname"><a href="../../d3/d27/class_day_z_physics.html">DayZPhysics</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/de4/_day_z_physics_8c_source.html#l00110">DayZPhysics.c:111</a></div></div>
<div class="ttc" id="aclass_day_z_physics_html_ac3d59bfe53ca68ae361735a40f548de2"><div class="ttname"><a href="../../d3/d27/class_day_z_physics.html#ac3d59bfe53ca68ae361735a40f548de2">DayZPhysics::RayCastBullet</a></div><div class="ttdeci">static proto bool RayCastBullet(vector begPos, vector endPos, PhxInteractionLayers layerMask, Object ignoreObj, out Object hitObject, out vector hitPosition, out vector hitNormal, out float hitFraction)</div></div>
<div class="ttc" id="aclass_debug_html"><div class="ttname"><a href="../../da/d7d/class_debug.html">Debug</a></div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00013">Debug.c:14</a></div></div>
<div class="ttc" id="aclass_debug_html_af7d58ee7a0b3ff54b49a277dbdd09db6"><div class="ttname"><a href="../../da/d7d/class_debug.html#af7d58ee7a0b3ff54b49a277dbdd09db6">Debug::DrawLine</a></div><div class="ttdeci">static Shape DrawLine(vector from, vector to, int color=0xFFFFFFFF, int flags=0)</div><div class="ttdef"><b>Definition:</b> <a href="../../de/d4c/3___game_2tools_2_debug_8c_source.html#l00349">Debug.c:349</a></div></div>
<div class="ttc" id="aclass_entity_a_i_html"><div class="ttname"><a href="../../df/df9/class_entity_a_i.html">EntityAI</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d45/3___game_2_entities_2_building_8c_source.html#l00001">Building.c:2</a></div></div>
<div class="ttc" id="aclass_melee_target_data_html"><div class="ttname"><a href="../../d8/d52/class_melee_target_data.html">MeleeTargetData</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00001">MeleeTargeting.c:2</a></div></div>
<div class="ttc" id="aclass_melee_target_data_html_a0eb9a6b8ca37fd3d1403884557fa27af"><div class="ttname"><a href="../../d8/d52/class_melee_target_data.html#a0eb9a6b8ca37fd3d1403884557fa27af">MeleeTargetData::HitPos</a></div><div class="ttdeci">vector HitPos</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00004">MeleeTargeting.c:4</a></div></div>
<div class="ttc" id="aclass_melee_target_data_html_a8a95f9d1cde3f7c4c7ebb4d4b683cddd"><div class="ttname"><a href="../../d8/d52/class_melee_target_data.html#a8a95f9d1cde3f7c4c7ebb4d4b683cddd">MeleeTargetData::HitComponent</a></div><div class="ttdeci">int HitComponent</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00005">MeleeTargeting.c:5</a></div></div>
<div class="ttc" id="aclass_melee_target_data_html_a8b6adaaa45ac0448b13e0c00abbccaba"><div class="ttname"><a href="../../d8/d52/class_melee_target_data.html#a8b6adaaa45ac0448b13e0c00abbccaba">MeleeTargetData::MeleeTargetData</a></div><div class="ttdeci">void MeleeTargetData(Object o, vector p, int c)</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00007">MeleeTargeting.c:7</a></div></div>
<div class="ttc" id="aclass_melee_target_data_html_abff57f73e043bd0cb8d801bc83ee9cfa"><div class="ttname"><a href="../../d8/d52/class_melee_target_data.html#abff57f73e043bd0cb8d801bc83ee9cfa">MeleeTargetData::Obj</a></div><div class="ttdeci">Object Obj</div><div class="ttdef"><b>Definition:</b> <a href="../../d6/d36/_melee_targeting_8c_source.html#l00003">MeleeTargeting.c:3</a></div></div>
<div class="ttc" id="aclass_object_html"><div class="ttname"><a href="../../d8/d83/class_object.html">Object</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d7/d68/_object_typed_8c_source.html#l00001">ObjectTyped.c:2</a></div></div>
<div class="ttc" id="aclassarray_html"><div class="ttname"><a href="../../d2/d41/classarray.html">array</a></div><div class="ttdoc">Result for an object found in CGame.IsBoxCollidingGeometryProxy.</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/dcd/_is_box_colliding_geometry_proxy_classes_8c_source.html#l00027">IsBoxCollidingGeometryProxyClasses.c:28</a></div></div>
<div class="ttc" id="aclassfloat_html_a984911aa6072c232bb876de8ed8904af"><div class="ttname"><a href="../../d4/dc3/classfloat.html#a984911aa6072c232bb876de8ed8904af">float::MAX</a></div><div class="ttdeci">const float MAX</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d13/_en_convert_8c_source.html#l00093">EnConvert.c:93</a></div></div>
<div class="ttc" id="aclassvector_html"><div class="ttname"><a href="../../d7/dfc/classvector.html">vector</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d13/_en_convert_8c_source.html#l00099">EnConvert.c:100</a></div></div>
<div class="ttc" id="aclassvector_html_a21d8662c860e105943718b2da59349e7"><div class="ttname"><a href="../../d7/dfc/classvector.html#a21d8662c860e105943718b2da59349e7">vector::DistanceSq</a></div><div class="ttdeci">static proto native float DistanceSq(vector v1, vector v2)</div><div class="ttdoc">Returns the squere distance between tips of two 3D vectors.</div></div>
<div class="ttc" id="aclassvector_html_a77831ca9c077a8dbd1b0aae7ba2a5d3d"><div class="ttname"><a href="../../d7/dfc/classvector.html#a77831ca9c077a8dbd1b0aae7ba2a5d3d">vector::Normalize</a></div><div class="ttdeci">proto float Normalize()</div><div class="ttdoc">Normalizes vector. Returns length.</div></div>
<div class="ttc" id="aclassvector_html_aad57f4c847a6ad08cf88f390961dd2db"><div class="ttname"><a href="../../d7/dfc/classvector.html#aad57f4c847a6ad08cf88f390961dd2db">vector::Distance</a></div><div class="ttdeci">static proto native float Distance(vector v1, vector v2)</div><div class="ttdoc">Returns the distance between tips of two 3D vectors.</div></div>
<div class="ttc" id="aclassvector_html_aed751dee971a2a172f3052c68f607111"><div class="ttname"><a href="../../d7/dfc/classvector.html#aed751dee971a2a172f3052c68f607111">vector::VectorToAngles</a></div><div class="ttdeci">proto vector VectorToAngles()</div><div class="ttdoc">Converts vector to spherical coordinates with radius = 1.</div></div>
<div class="ttc" id="agameplay_8c_html_aebb1fa6632d513bc849994e7b6c9c93d"><div class="ttname"><a href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a></div><div class="ttdeci">proto native CGame GetGame()</div></div>
<div class="ttc" id="agroup___colors_html_ga99b2555651fb3bdd7bca23e5b6553968"><div class="ttname"><a href="../../dd/d13/group___colors.html#ga99b2555651fb3bdd7bca23e5b6553968">COLOR_GREEN</a></div><div class="ttdeci">const int COLOR_GREEN</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/dca/1___core_2constants_8c_source.html#l00064">constants.c:64</a></div></div>
<div class="ttc" id="agroup___debug_shape_html_gae99018d13c3c8a3cc164600046082d04"><div class="ttname"><a href="../../d6/dae/group___debug_shape.html#gae99018d13c3c8a3cc164600046082d04">ShapeFlags</a></div><div class="ttdeci">ShapeFlags</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d19/_en_debug_8c_source.html#l00125">EnDebug.c:126</a></div></div>
<div class="ttc" id="agroup___diag_menu_html_d2/dd2/class_diag_menu"><div class="ttname"><a href="../../dc/d49/group___diag_menu.html#d2/dd2/class_diag_menu">DiagMenu</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d19/_en_debug_8c_source.html#l00232">EnDebug.c:233</a></div></div>
<div class="ttc" id="agroup___diag_menu_html_ga7393b4dbcb2442ab520c89d54b390fed"><div class="ttname"><a href="../../dc/d49/group___diag_menu.html#ga7393b4dbcb2442ab520c89d54b390fed">DiagMenu::GetBool</a></div><div class="ttdeci">static proto native bool GetBool(int id, bool reverse=false)</div></div>
<div class="ttc" id="agroup___math3_d_a_p_i_html_da/d94/class_math3_d"><div class="ttname"><a href="../../d5/dc8/group___math3_d_a_p_i.html#da/d94/class_math3_d">Math3D</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d4c/_en_math3_d_8c_source.html#l00027">EnMath3D.c:28</a></div></div>
<div class="ttc" id="agroup___math3_d_a_p_i_html_ga5bd1deb1c96276d94eeec6fe40955c41"><div class="ttname"><a href="../../d5/dc8/group___math3_d_a_p_i.html#ga5bd1deb1c96276d94eeec6fe40955c41">Vector</a></div><div class="ttdeci">proto native vector Vector(float x, float y, float z)</div><div class="ttdoc">Vector constructor from components.</div></div>
<div class="ttc" id="agroup___math3_d_a_p_i_html_ga6355d439d382de23a6bde149dce4ce27"><div class="ttname"><a href="../../d5/dc8/group___math3_d_a_p_i.html#ga6355d439d382de23a6bde149dce4ce27">Math3D::AngleFromPosition</a></div><div class="ttdeci">static proto float AngleFromPosition(vector origin, vector originDir, vector target)</div><div class="ttdoc">Angle that a target is from the direction of an origin.</div></div>
<div class="ttc" id="agroup___math3_d_a_p_i_html_gaa40fb02e82bbd890f161df78fc8cdc55"><div class="ttname"><a href="../../d5/dc8/group___math3_d_a_p_i.html#gaa40fb02e82bbd890f161df78fc8cdc55">Math3D::NearestPoint</a></div><div class="ttdeci">static proto vector NearestPoint(vector beg, vector end, vector pos)</div><div class="ttdoc">Point on line beg .. end nearest to pos.</div></div>
<div class="ttc" id="agroup___math3_d_a_p_i_html_gaa5d7b9d9e2c8f7d42e0e63415e512d20"><div class="ttname"><a href="../../d5/dc8/group___math3_d_a_p_i.html#gaa5d7b9d9e2c8f7d42e0e63415e512d20">Math3D::ConePoints</a></div><div class="ttdeci">static proto void ConePoints(vector origin, float length, float halfAngle, float angleOffset, out vector leftPoint, out vector rightPoint)</div><div class="ttdoc">Calculates the points of a right 2D cone in 3D space.</div></div>
<div class="ttc" id="agroup___math_html_d4/d34/class_math"><div class="ttname"><a href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d34/_en_math_8c_source.html#l00006">EnMath.c:7</a></div></div>
<div class="ttc" id="agroup___math_html_ga1ac33c7be3c1e52ae6b70fe58c78266c"><div class="ttname"><a href="../../d5/d98/group___math.html#ga1ac33c7be3c1e52ae6b70fe58c78266c">Math::Lerp</a></div><div class="ttdeci">static proto float Lerp(float a, float b, float time)</div><div class="ttdoc">Linearly interpolates between 'a' and 'b' given 'time'.</div></div>
<div class="ttc" id="agroup___math_html_ga1ea52907ba49a5706b41108910975de7"><div class="ttname"><a href="../../d5/d98/group___math.html#ga1ea52907ba49a5706b41108910975de7">Math::SqrFloat</a></div><div class="ttdeci">static proto float SqrFloat(float f)</div><div class="ttdoc">Returns squared value.</div></div>
<div class="ttc" id="agroup___math_html_ga5e7cfa6eb9adaec1bb0ee6314bd32c2c"><div class="ttname"><a href="../../d5/d98/group___math.html#ga5e7cfa6eb9adaec1bb0ee6314bd32c2c">Math::Tan</a></div><div class="ttdeci">static proto float Tan(float angle)</div><div class="ttdoc">Returns tangent of angle in radians.</div></div>
<div class="ttc" id="agroup___math_html_ga87cce5b3869bb15303abcbe531f50d32"><div class="ttname"><a href="../../d5/d98/group___math.html#ga87cce5b3869bb15303abcbe531f50d32">Math::Atan2</a></div><div class="ttdeci">static proto float Atan2(float y, float x)</div><div class="ttdoc">Returns angle in radians from tangent.</div></div>
<div class="ttc" id="agroup___math_html_gad73851cb23a468ee6eb705d0ec76e141"><div class="ttname"><a href="../../d5/d98/group___math.html#gad73851cb23a468ee6eb705d0ec76e141">Math::RAD2DEG</a></div><div class="ttdeci">static const float RAD2DEG</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d34/_en_math_8c_source.html#l00016">EnMath.c:16</a></div></div>
<div class="ttc" id="agroup___math_html_gadf6cda0885b5257cc109a3420ea11cd6"><div class="ttname"><a href="../../d5/d98/group___math.html#gadf6cda0885b5257cc109a3420ea11cd6">Math::DEG2RAD</a></div><div class="ttdeci">static const float DEG2RAD</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d34/_en_math_8c_source.html#l00017">EnMath.c:17</a></div></div>
<div class="ttc" id="agroup___math_html_gadf8820d46eee5033af2e12212c22b16e"><div class="ttname"><a href="../../d5/d98/group___math.html#gadf8820d46eee5033af2e12212c22b16e">Math::AbsFloat</a></div><div class="ttdeci">static proto float AbsFloat(float f)</div><div class="ttdoc">Returns absolute value.</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_f61fac3e195407e8bd798ede36822932.html">Classes</a></li><li class="navelem"><a class="el" href="../../d6/d36/_melee_targeting_8c.html">MeleeTargeting.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
